#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire500five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five5004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five5004xi = {
                1: '-103x160y462z',
                2: '-103x456y175z',
                3: '-104x309y378z',
                4: '-109x335y354z',
                5: '-10x2y499z',
                6: '-114x158y460z',
                7: '-122x307y375z',
                8: '-125x155y458z',
                9: '-127x332y350z',
                10: '-127x452y171z',
                11: '-136x152y456z',
                12: '-139x303y371z',
                13: '-146x328y347z',
                14: '-147x148y454z',
                15: '-151x446y166z',
                16: '-157x299y368z',
                17: '-158x143y452z',
                18: '-15x147y477z',
                19: '-15x3y499z',
                20: '-164x323y343z',
                21: '-169x137y449z',
                22: '-174x293y364z',
                23: '-175x439y161z',
                24: '-179x131y447z',
                25: '-183x317y339z',
                26: '-190x124y445z',
                27: '-191x287y361z',
                28: '-198x431y156z',
                29: '-1x0y499z',
                30: '-200x116y443z',
                31: '-201x310y336z',
                32: '-208x279y358z',
                33: '-209x107y440z',
                34: '-20x3y499z',
                35: '-219x302y332z',
                36: '-219x98y438z',
                37: '-221x421y152z',
                38: '-225x271y354z',
                39: '-228x88y436z',
                40: '-236x77y433z',
                41: '-237x292y328z',
                42: '-23x151y475z',
                43: '-241x261y351z',
                44: '-244x410y147z',
                45: '-244x66y431z',
                46: '-251x54y428z',
                47: '-254x282y324z',
                48: '-257x251y347z',
                49: '-258x41y425z',
                50: '-264x28y423z',
                51: '-266x398y142z',
                52: '-26x2y499z',
                53: '-270x15y420z',
                54: '-271x271y321z',
                55: '-272x239y343z',
                56: '-274x0y417z',
                57: '-287x227y340z',
                58: '-287x258y317z',
                59: '-287x384y137z',
                60: '-301x213y336z',
                61: '-302x245y313z',
                62: '-308x370y133z',
                63: '-315x199y332z',
                64: '-317x230y309z',
                65: '-31x1y499z',
                66: '-328x184y329z',
                67: '-328x354y128z',
                68: '-32x154y474z',
                69: '-331x215y305z',
                70: '-340x168y325z',
                71: '-345x199y301z',
                72: '-347x337y123z',
                73: '-351x151y321z',
                74: '-358x182y297z',
                75: '-35x336y368z',
                76: '-362x133y317z',
                77: '-365x320y118z',
                78: '-369x164y293z',
                79: '-36x0y498z',
                80: '-371x115y313z',
                81: '-380x146y289z',
                82: '-380x96y309z',
                83: '-382x301y113z',
                84: '-387x77y305z',
                85: '-390x126y285z',
                86: '-394x57y301z',
                87: '-398x281y108z',
                88: '-399x107y281z',
                89: '-399x37y297z',
                90: '-407x86y277z',
                91: '-413x260y103z',
                92: '-413x65y272z',
                93: '-419x44y268z',
                94: '-41x157y472z',
                95: '-423x22y264z',
                96: '-426x0y260z',
                97: '-427x239y98z',
                98: '-440x216y94z',
                99: '-452x194y89z',
                100: '-462x170y84z',
                101: '-471x146y79z',
                102: '-479x121y74z',
                103: '-485x19y352z',
                104: '-485x96y69z',
                105: '-490x70y64z',
                106: '-494x45y59z',
                107: '-496x19y54z',
                108: '-51x159y471z',
                109: '-53x310y387z',
                110: '-53x337y364z',
                111: '-54x461y185z',
                112: '-5x1y499z',
                113: '-61x160y469z',
                114: '-70x311y384z',
                115: '-71x161y467z',
                116: '-71x338y361z',
                117: '-79x459y180z',
                118: '-81x161y465z',
                119: '-87x311y381z',
                120: '-90x337y357z',
                121: '-92x161y464z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire500five4xi" usage = "target function for charge5004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire500five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE500FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE500FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE500FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE500FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE500FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five5004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE500FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE500FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE500FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five5004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five5004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE500FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE500FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE500FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire500five4xi.py                             
# -------------------------------------------------------------------------------------------------                